<!--******************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 *******************************************************************************-->
<div
  [ngSwitch]="contextAttribute?.attribute?.dataType"
  [style.width]="width"
  [ngClass]="{ 'attribute-editor-wrapper': contextAttribute?.attribute?.unit?.length > 0 }"
>
  <ng-container *ngSwitchCase="'STRING_SEQUENCE'">
    <ng-container *ngTemplateOutlet="sequence_editor"></ng-container>
  </ng-container>
  <ng-container *ngSwitchCase="'INTEGER_SEQUENCE'">
    <ng-container *ngTemplateOutlet="sequence_editor"></ng-container>
  </ng-container>
  <ng-container *ngSwitchCase="'DOUBLE_SEQUENCE'">
    <ng-container *ngTemplateOutlet="sequence_editor"></ng-container>
  </ng-container>
  <ng-container *ngSwitchCase="'FLOAT_SEQUENCE'">
    <ng-container *ngTemplateOutlet="sequence_editor"></ng-container>
  </ng-container>
  <ng-template #sequence_editor>
    <div class="sequence-edit-field">
      {{ currentSequenceValue }}
      <button
        style="min-width: 3.5rem"
        pButton
        type="button"
        label="{{ 'details.mdm-detail-descriptive-data.btn-edit' | translate }}"
        (click)="editDialogVisible = true"
      ></button>
      <p-dialog
        [modal]="true"
        header="{{ 'details.mdm-detail-descriptive-data.select-value' | translate }}"
        [(visible)]="editDialogVisible"
      >
        <div class="sequence-editor-wrapper">
          <div
            *ngFor="let attr of contextAttribute?.attribute.value[contextAttribute?.contextGroup]; let i = index; trackBy: trackByFn"
            [ngSwitch]="contextAttribute?.attribute?.dataType"
            class="sequency-editor-entry-wrapper"
          >
            <button
              pButton
              pRipple
              type="button"
              icon="pi pi-times"
              class="p-button-rounded p-button-outlined p-button-danger"
              (click)="deleteSequenceEntry(i)"
            ></button>
            <input
              *ngSwitchCase="'STRING_SEQUENCE'"
              pInputText
              type="text"
              [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup][i]"
            />
            <input
              *ngSwitchDefault
              pInputText
              type="number"
              [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup][i]"
            />
          </div>
          <div class="sequency-editor-new-entry-wrapper">
            <button
              pButton
              pRipple
              type="button"
              icon="pi pi-plus"
              class="p-button-rounded p-button-outlined p-button-success"
              (click)="addNewSequenceEntry()"
            ></button>
          </div>
        </div>
        <ng-template pTemplate="footer">
          <button
            pButton
            pRipple
            label="{{ 'details.mdm-detail-descriptive-data.btn-save' | translate }}"
            icon="pi pi-check"
            class="p-button-text"
            (click)="getSequenceAttributeValue(); editDialogVisible = false"
          ></button>
        </ng-template>
      </p-dialog></div
  ></ng-template>

  <ng-container *ngSwitchCase="'STRING'">
    <ng-container *ngIf="contextAttribute?.attribute.valueList; else defaultString">
      <p-dropdown
        [options]="valueListValues | async"
        #inputField="ngModel"
        [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
        [style]="{ width: '100%' }"
        [editable]="!contextAttribute?.attribute.valueListRef"
        [autoDisplayFirst]="false"
        [showClear]="true"
        appendTo="body"
        [name]="contextAttribute?.attribute.name"
        [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
        [pattern]="validationPattern | async"
        [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
        [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
        tooltipPosition="left"
      ></p-dropdown>
    </ng-container>

    <ng-template #defaultString>
      <input
        pInputText
        type="text"
        #inputField="ngModel"
        [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
        class="attreditor"
        [name]="contextAttribute?.attribute.name"
        [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
        [pattern]="validationPattern | async"
        [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
        [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
        tooltipPosition="left"
      />
    </ng-template>
  </ng-container>

  <input
    *ngSwitchCase="'FLOAT'"
    pInputText
    type="number"
    #inputField="ngModel"
    [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
    class="attreditor"
    [name]="contextAttribute?.attribute.name"
    [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
    [pattern]="validationPattern | async"
    [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    tooltipPosition="left"
  />
  <input
    *ngSwitchCase="'SHORT'"
    pInputText
    type="number"
    #inputField="ngModel"
    [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
    class="attreditor"
    [name]="contextAttribute?.attribute.name"
    [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
    [pattern]="validationPattern | async"
    [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    tooltipPosition="left"
  />
  <input
    *ngSwitchCase="'INTEGER'"
    pInputText
    type="number"
    #inputField="ngModel"
    [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
    class="attreditor"
    [name]="contextAttribute?.attribute.name"
    [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
    [pattern]="validationPattern | async"
    [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    tooltipPosition="left"
  />
  <input
    *ngSwitchCase="'LONG'"
    pInputText
    type="number"
    #inputField="ngModel"
    [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
    class="attreditor"
    [name]="contextAttribute?.attribute.name"
    [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
    [pattern]="validationPattern | async"
    [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    tooltipPosition="left"
  />
  <input
    *ngSwitchCase="'DOUBLE'"
    pInputText
    type="number"
    #inputField="ngModel"
    [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
    class="attreditor"
    [name]="contextAttribute?.attribute.name"
    [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
    [pattern]="validationPattern | async"
    [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
    tooltipPosition="left"
  />
  <ng-container *ngSwitchCase="'DATE'">
    <mdm-p-calendar-wrapper
      [hourFormat]="hourFormat"
      styleClass="attreditor"
      [showTime]="true"
      [showSeconds]="true"
      [(dateTime)]="dateTime"
      (selectDateTime)="onDateChanged()"
      appendTo="body"
    ></mdm-p-calendar-wrapper>
  </ng-container>

  <div class="field-checkbox" *ngSwitchCase="'BOOLEAN'">
    <p-checkbox
      #inputField="ngModel"
      [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
      [binary]="true"
      trueValue="true"
      falseValue="false"
      inputId="BOOLEAN_EDITOR"
      styleClass="attreditorcheckbox"
      [name]="contextAttribute?.attribute.name"
      [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
      [pattern]="validationPattern | async"
      [placeholder]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
      [pTooltip]="(validationPattern | async) ? 'Pattern: ' + (validationPattern | async) : ''"
      tooltipPosition="left"
    ></p-checkbox>
    <label for="BOOLEAN_EDITOR">{{ contextAttribute?.attribute.value[contextAttribute?.contextGroup] }}</label>
  </div>
  <p-dropdown
    *ngSwitchCase="'ENUMERATION'"
    [options]="enumerations[contextAttribute?.attribute.enumName]"
    optionLabel="value"
    optionValue="value"
    [autoDisplayFirst]="false"
    [showClear]="true"
    (onClear)="clear()"
    #inputField="ngModel"
    [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
    class="attreditor"
    [name]="contextAttribute?.attribute.name"
    [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
  ></p-dropdown>
  <p-multiSelect
    *ngSwitchCase="'ENUMERATION_SEQUENCE'"
    [options]="enumerations[contextAttribute?.attribute.enumName]"
    optionLabel="value"
    optionValue="value"
    #inputField="ngModel"
    [(ngModel)]="contextAttribute?.attribute.value[contextAttribute?.contextGroup]"
    [filter]="false"
    class="attreditor"
    [name]="contextAttribute?.attribute.name"
    [required]="contextAttribute?.attribute.mandatory || contextAttribute?.attribute.optional === false"
  ></p-multiSelect>
  <mdm-file-link-sequence-editor
    *ngSwitchCase="'FILE_LINK'"
    class="attreditor"
    [contextAttribute]="contextAttribute"
  ></mdm-file-link-sequence-editor>
  <mdm-file-link-sequence-editor
    *ngSwitchCase="'FILE_LINK_SEQUENCE'"
    class="attreditor"
    [contextAttribute]="contextAttribute"
  ></mdm-file-link-sequence-editor>
  <mdm-file-link-sequence-editor
    *ngSwitchCase="'FILE_RELATION'"
    class="attreditor"
    [contextAttribute]="contextAttribute"
  ></mdm-file-link-sequence-editor>
  <div *ngSwitchDefault>
    {{ contextAttribute?.attribute | attributeValue : contextAttribute?.contextGroup }}
  </div>
  <span *ngIf="contextAttribute?.attribute?.unit?.length > 0" class="inlinecontent">{{ contextAttribute?.attribute.unit }}</span>
</div>
